#ifndef DLX_SOMA_SOLVER_HPP
#define DLX_SOMA_SOLVER_HPP



#include <limits>
#include <set>
#include <string>
#include <vector>




namespace soma
  {



  namespace solver
    {



    namespace dlx_algorithm
      {



      class CDLXSomaSolver : public CDLXAlgorithm<CDLXSomaSolver>
        {

        friend class CDLXAlgorithm<CDLXSomaSolver>;


        private :

          template
            <
            typename DataT
            >
          inline void generateSparseMatrix
                                         (
                                         const DataT& data
                                         );



        public :

          template
            <
            typename DataT
            >
          CDLXSomaSolver
                       (
                       const DataT& data,
                       const unsigned int maxNbSolutions=std::numeric_limits<unsigned int>::max()
                       ) : CDLXAlgorithm<CDLXSomaSolver>
                                                       (
                                                       data,
                                                       maxNbSolutions
                                                       ) {}

        };



      }



    }



  }



#endif  //  DLX_SOMA_SOLVER_HPP
