#ifndef IS_OF_TYPE_HPP
#define IS_OF_TYPE_HPP



#include <string>



namespace soma
  {



  namespace utils
    {

    namespace general
      {



/*
  Modification de l'excellente fonction is_of_type que l'on peut trouver dans la FAQ C++ du site developpez.com
   la page http://cpp.developpez.com/faq/cpp/?page=strings#STRINGS_convert_to.
  Cette fonction is_of_type permet de convertir un objet de type std::string en objet de n'importe type. Elle doit
  tre instancie avec le type vers lequel on souhaite convertir le std::string.

  La fonction isOfType est identique  is_of_type sauf qu'il est possible de rcuprer la valeur contenue dans la
  chane dans une rfrence donne en argument. Cette valeur est rcupre uniquement si elle est du mme type que
  l'argument. Il n'est pas ncessaire de l'instancier.

  Argument 1 :
    - type : rfrence sur un type paramtr T.
    - nom : toAssign.
    - toAssign est la rfrence dans laquelle on souhaite rcuprer la valeur contenue dans la chane si possible.
      toAssign indique galement le type vers lequel la conversion doit s'oprer.

  Argument 2 :
    - type : std::string.
    - nom : str.
    - str est une chane de caraxtres contenant la valeur  convertir.

  Retour :
    - type : bool.
    - nom : isOfTypeT.
    - isOfTypeT est assign  true si la conversion a pu tre effectue, false sinon.
*/
      template
        <
        typename T
        >
      inline const bool isOfType
                               (
                               T& toAssign,
                               const std::string& str
                               );



      }



    }



  }



#endif  //  IS_OF_TYPE_HPP
